module Plugin::Save::Ttdeck
  MAJOR_STR = ['I', 'II', 'III', 'IV', 'V', 'VI', 'VII', 'VIII', 'IX', 'X']
  def desc
    Uconv.u8tosjis 'ツアートライアル デッキシート出力'
  end
  def save(deck)
    filename = SWin::CommonDialog::openFilename(nil, [[Uconv.u8tosjis('デッキ登録用紙(*.xls)'), '*.xls']])
    if filename
      xl = WIN32OLE.new 'Excel.Application'
      openExcelWorkbook(filename){|book|
        sheet = book.Worksheets.Item 1
        sheet.extend WorkSheet
        hash = YAML.load deck
        x = 2
        y = 15
        sx = 2
        sy = 39
        hash.each{|value|
          card = value[:card]
          num  = value[:num]
          side = value[:side]
          edition = card.edition.to_s
          edition.gsub!(/^\d+/){|s|
            MAJOR_STR[s.to_i - 1]
          }
          if side
            sheet[sy, sx]     = edition
            sheet[sy, sx + 1] = card.num
            sheet[sy, sx + 2] = Uconv.u8tosjis card.name
            sheet[sy, sx + 3] = num
            sy += 1
            if sy > 43
              sy = 39
              sx = 7
            end
          else
            sheet[y, x]     = edition
            sheet[y, x + 1] = card.num
            sheet[y, x + 2] = Uconv.u8tosjis card.name
            sheet[y, x + 3] = num
            y += 1
            if y > 34
              y = 15
              x = 7
            end
          end
        }
        book.Save
      }
    end
  end
  def openExcelWorkbook(filename)
    xl = WIN32OLE.new('Excel.Application')
    xl.Visible = true
    book = xl.Workbooks.Open(filename)
    begin
      yield book
    ensure
      xl.Workbooks.Close
      xl.Quit
    end
  end
  module WorkSheet
    def []=(y, x, value)
      cell = self.Cells.Item y,x
      if cell.MergeCells
        cell.MergeArea.Item(1,1).Value = value
      else
        cell.Value = value
      end
    end
  end
end

